if not _G.Infinamy then
	_G.Infinamy = _G.Infinamy or {}
	Infinamy.HIGHEST_INF = 500
	Infinamy._path = ModPath
	Infinamy._data_path = SavePath .. "infinamy.txt"
	Infinamy.version = "1.2"
	Infinamy._settings = {}

	function Infinamy:Default()
		Infinamy._settings = {}
		Infinamy._settings.version = Infinamy.version
		Infinamy._settings.highest_seen = Infinamy.HIGHEST_INF
	end

	Infinamy:Default()

	function Infinamy:Load()
		local file = io.open(self._data_path, "r")
		if file then
			local decoded = json.decode(file:read("*all")) or {}
			for k, v in pairs(decoded) do
				self._settings[k] = v
			end
			file:close()
		else
			self:Default()
			self:Save()
		end
	end

	function Infinamy:Save()
		local file = io.open(self._data_path, "w+")
		if file then
			file:write(json.encode(self._settings))
			file:close()
		end
	end

	Infinamy:Load()
end



function InfamyTweakData:fill_ranks(rank)
	self.ranks = math.max(rank + 1, self.ranks)
	if Infinamy._settings.highest_seen < rank then
		Infinamy._settings.highest_seen = rank
		Infinamy:Save()
	end
end

Hooks:PostHook(InfamyTweakData, "init", "Infinamy_InfamyTweakData_init", function(self)
	if Global and Global.experience_manager then
		self:fill_ranks(Application:digest_value(Global.experience_manager.rank, false))
	end
end)