local FONT = tweak_data.menu.pd2_small_font
local FONT_SIZE = tweak_data.menu.pd2_small_font_size
local TEXT_COLOR = tweak_data.screen_colors.text
local MOUSEOVER_COLOR = tweak_data.screen_colors.button_stage_2
local BUTTON_COLOR = tweak_data.screen_colors.button_stage_3

Hooks:PostHook(InfamyTreeGui, "_setup", "Infinamy_InfamyTreeGui__setup", function(self)
	local revert_inf_button = self.infamous_panel:panel({
		name = "revert_infamous_button",
		y = 5,
		x = 210,
		h = FONT_SIZE + 10
	})
	revert_inf_button:text({
		name = "revert_infamous_text",
		align = right,
		layer = 3,
		text = managers.localization:text("infinamy_reset_button", {
			level = Infinamy.HIGHEST_INF
		}),
		h = FONT_SIZE,
		font = FONT,
		font_size = FONT_SIZE,
		color = managers.experience:current_rank() > Infinamy.HIGHEST_INF and BUTTON_COLOR or tweak_data.screen_colors.item_stage_3
	})
end)

local Infinamy_InfamyTreeGui_mouse_moved = InfamyTreeGui.mouse_moved

function InfamyTreeGui:mouse_moved(o, x, y)
	if managers.menu_scene and managers.menu_scene:input_focus() then
		return false
	end

	local used = false
	local pointer = "arrow"

	if managers.experience:current_rank() > Infinamy.HIGHEST_INF then
		local rev_button = self.infamous_panel:child("revert_infamous_button")
		if rev_button:inside(x, y) then
			used = true
			pointer = "link"
			
			if not self._rev_infamous_highlight then
				self._rev_infamous_highlight = true

				rev_button:child("revert_infamous_text"):set_color(MOUSEOVER_COLOR)
				managers.menu_component:post_event("highlight")
			end
		elseif self._rev_infamous_highlight then
			self._rev_infamous_highlight = false

			rev_button:child("revert_infamous_text"):set_color(BUTTON_COLOR)
		end
	end

	if not used then
		return Infinamy_InfamyTreeGui_mouse_moved(self, o, x, y)
	end

	return used, pointer
end

Hooks:PostHook(InfamyTreeGui, "mouse_pressed", "Infinamy_InfamyTreeGui_mouse_pressed", function(self, button, x, y)
	if button ~= Idstring("0") then
		return
	end
	if managers.experience:current_rank() > Infinamy.HIGHEST_INF and self.infamous_panel:child("revert_infamous_button"):inside(x, y) then
		self.scroll:set_input_focus(false)
		MenuCallbackHandler:set_back_infamy_warning()
		return
	end
end)