---------------------------------------------- Localization ------------------------------------------------
Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_Infinamy", function(loc)

	for _, filename in pairs(file.GetFiles(Infinamy._path .. "loc/")) do
		local str = filename:match('^(.*).txt$')
		if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
			loc:load_localization_file(Infinamy._path .. "loc/" .. filename)
			break
		end
	end

	loc:load_localization_file(Infinamy._path .. "loc/english.txt", false)
end)

---------------------------------------------- Undo -------------------------------------------------------

function MenuCallbackHandler:set_back_infamy_warning()
	local dialog_data = {}
	if managers.experience:current_rank() <= Infinamy.HIGHEST_INF then
			dialog_data.title = string.upper(managers.localization:text("dialog_error_title"))
			dialog_data.text = managers.localization:text("infinamy_not_enough", {
				level = Infinamy.HIGHEST_INF
			})
				
			local ok_button = {}
			ok_button.text = managers.localization:text("dialog_ok")
			ok_button.callback_func = callback(self, self, "_dialog_clear_progress_no")
			ok_button.cancel_button = true
			dialog_data.button_list = {ok_button}
			managers.system_menu:show(dialog_data)
			return
	end
	dialog_data.title = string.upper(managers.localization:text("dialog_warning_title"))
	dialog_data.text = managers.localization:text("infinamy_reset_warning", {
				level = Infinamy.HIGHEST_INF
			})
	local yes_button = {}
	yes_button.text = managers.localization:text("dialog_yes")
	function yes_button.callback_func()
		managers.experience:set_current_rank(Infinamy.HIGHEST_INF - 1)
		managers.menu:open_node("blackmarket_preview_node", {
			{
				back_callback = callback(MenuCallbackHandler, MenuCallbackHandler, "set_back_infamy_callback")
			}
		})
		managers.menu:post_event("infamous_stinger_generic")
		managers.menu_scene:spawn_infamy_card(Infinamy.HIGHEST_INF)
	end
	local no_button = {}
	no_button.text = managers.localization:text("dialog_no")
	no_button.callback_func = callback(self, self, "_dialog_clear_progress_no")
	no_button.cancel_button = true
	dialog_data.button_list = {yes_button, no_button}
	managers.system_menu:show(dialog_data)
end

function MenuCallbackHandler:set_back_infamy_callback(item)
	managers.experience:set_current_rank(Infinamy.HIGHEST_INF)
	managers.menu_scene:destroy_infamy_card()
	if managers.menu_component then
		managers.menu_component:refresh_player_profile_gui()
	end
	managers.savefile:save_progress()
	managers.savefile:save_setting(true)
	local logic = managers.menu:active_menu().logic

	if logic then
		logic:refresh_node()
		logic:select_item("crimenet")
	end
	managers.menu:post_event("infamous_player_join_stinger")
end